<template>
  <div
    class="flex flex-col items-start w-full rounded-lg"
    :class="readOnly ? aleph ? 'border border-darkGrey' : '' : 'border border-darkGrey'"
  >
    <div class="w-full mx-auto">
      <div
        :id="String(editorId)"
        class="w-full min-w-full max-w-full"
        :class="[readOnly ? aleph ? 'editorjs-read-only-aleph read-only kabam' :
          fullWidth ? 'editorjs-read-only-studio editor-full-width !p-0' :
            'editorjs-read-only-studio read-only kabam !p-0' : 'not-read-only']"
      />
    </div>
  </div>
</template>

<script setup>
import { ref, watch, onMounted } from "vue";
import EditorJs from "@editorjs/editorjs"
import HeaderTool from "@editorjs/header"
import RawTool from "@editorjs/raw"
import ImageTool from "@editorjs/image"
import CheckListTool from "@editorjs/checklist"
import DragDrop from 'editorjs-drag-drop';
import textAlignementTune from "editorjs-text-alignment-blocktune"
import ParagraphTool from "@editorjs/paragraph"
import UndoTool from "editorjs-undo"
import NestedListTool from '@editorjs/nested-list'
import UnsplashImageTool from "editorjs-inline-image";
import QuoteTool from "./quote.js"
import DividerTool from "./divider.js"
import SpacerTool from "./spacer.js"
import axios from "axios";
import { v4 as uuidv4 } from "uuid";
import Table from '@editorjs/table'
import ChangeCase from './changeCase/change-case.js';
import ColorPlugin from './color/color.js'
import Underline from '@editorjs/underline';
import editorJsParser from 'editorjs-html';
import Strikethrough from '@sotaproject/strikethrough';

const emits = defineEmits(["on-save"])

const props = defineProps({
  data: { type: Object, required: false },
  htmlData: { type: String || Object, default: '' },
  aleph: { type: Boolean, default: false },
  readOnly: { type: Boolean, default: false },
  editorId: { type: String, required: true },
  createImageUrl: { type: String, required: true },
  fullWidth: { type: Boolean, default: false },
});

onMounted(async () => {
  if (props?.htmlData) {
    await editor.isReady;

    editor.blocks.renderFromHTML(props?.htmlData);
  }
});

const editor = new EditorJs({
  readOnly: props.readOnly,
  holder: String(props.editorId),
  minHeight: 0,
  data: props?.data,
  inlineToolbar: true,
  placeholder: "Start writing text here or add content to the editor using “+” button",
  onReady: () => {
    new DragDrop(editor);

    const undo = new UndoTool({ editor });
    undo.initialize(props?.data);
  },
  onChange: onChangeHandler,
  tools: {
    header: {
      class: HeaderTool,
      inlineToolbar: true,
      config: {
        placeholder: "Enter a header",
        levels: [1, 2, 3, 4],
        defaultLevel: 3
      },
      tunes: ["align"]
    },
    list: {
      class: NestedListTool,
      inlineToolbar: true,
      config: {
        defaultStyle: "unordered"
      }
    },
    checklist: {
      class: CheckListTool,
      inlineToolbar: true,
    },
    quote: {
      class: QuoteTool,
      inlineToolbar: true,
    },
    spacer: {
      class: SpacerTool
    },
    divider: {
      class: DividerTool,
      config: {
        fullWidth: true,
      }
    },
    image: {
      class: ImageTool,
      config: {
        uploader: {
          async uploadByFile(file) {
            const res = await axios.post(
              props.createImageUrl,
              { image: file },
              { headers: { 'Content-Type': 'multipart/form-data' } },
            );
            return res.data;
          },
          async uploadByUrl(file) {
            const res = await axios.post(props.createImageUrl,
              { image: file },
              { headers: { 'Content-Type': 'multipart/form-data' }
            });
            return res.data;
          },
        },
      },
    },
    inlineImage: {
      class: UnsplashImageTool,
      inlineToolbar: true,
      toolbox: {
        icon: '<svg xmlns="http://www.w3.org/2000/svg" class="icon icon-tabler icon-tabler-brand-unsplash" width="21" height="21" viewBox="1 1 21 21" stroke-width="2" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"> <path stroke="none" d="M0 0h24v24H0z" fill="none"/> <path d="M4 11h5v4h6v-4h5v9h-16zm5 -7h6v4h-6z" /></svg>',
        title: 'Unsplash image'
      },
      config: {
        embed: {
          display: false,
        },
        unsplash: {
          appName: 'Aleph',
          clientId: import.meta.env.VITE_UNSPLASH_ACCESS_KEY,
        }
      }
    },
    table: {
      class: Table
    },
    paragraph: {
      class: ParagraphTool,
      inlineToolbar: true,
      tunes: ["align"],
      config: {
        preserveBlank: true,
      }
    },
    raw: {
      class: RawTool,
      tunes: ["align"]
    },
    paragraph: {
      class: ParagraphTool,
      inlineToolbar: true,
      tunes: ["align"]
    },
    align: {
      class: textAlignementTune,
      config:{
        default: "left",
      },
      inlineToolbar: true
    },
    underline: Underline,
    strikethrough: Strikethrough,
    changeCase: {
      class: ChangeCase,
      config: {
        showLocaleOption: true, // enable locale case options
        locale: 'tr' // or ['tr', 'TR', 'tr-TR']
      }
    },
    Color: {
      class: ColorPlugin,
      config: {
        colorCollections: ['#EC7878','#9C27B0','#673AB7','#3F51B5','#0070FF','#03A9F4','#00BCD4','#4CAF50','#8BC34A','#CDDC39', '#FFF'],
        defaultColor: '#FF0000',
        type: 'text',
        customPicker: true,
      }
    },
  }
});

watch(props, () => {
  if (editor?.readOnly?.isEnabled != props.readOnly) {
    editor.readOnly.toggle(props.readOnly)
  }
});

const listWithContent = (data) => {
  return {
    id: uuidv4(),
    type: "list",
    data: {
      items: [
        {
          content: data,
          items: [],
        },
      ],
    },
  }
}

// const convertData = () => {
//   editor.save().then((data) => {
//     console.log(parser(data))
//   });
// }

// const injectToTipTap = async () => {
//   let data = await editor.save()

//   data = parser(data)
//   emits('injectToTipTap', data)
// }

// const parser = (data) => {
//   let finalHTML = '';

//   const inlineParser = (block) => {
//     return `<img class="block py-0" src="${block.data.url}" alt="" />`
//   }

//   const dividerParser = (block) => {
//     return `<hr class="${block?.data?.fullWidth ? 'w-full' : 'w-1/2'} my-4 flex items-center justify-center h-0.5 bg-middleGrey transition-all duration-200" />`
//   }

//   const rawParser = (block) => {
//     return `<pre><code class="language-html">${String(block?.data?.html)}</code></pre>`
//   }

//   const checklistParser = (block) => {
//     const listStyle = "ul";

//     let list = ""
//     for (let item of block.data.items) {
//       let element = `<li data-type="taskItem" data-checked="${item.checked}">${item.text}</li>`
//       list += element
//     }

//     return `<${listStyle} data-type="taskList">${list}</${listStyle}>`;
//   }

//   const quoteParser = (block) => {
//     return `<blockquote>${block?.data?.text}</blockquote>`
//   }
//   const tableParser = (block) => {
//     let tableHtml = ''
//     const tableStart = '<table><tbody>'
//     const tableEnd = '</tbody></table>'

//     tableHtml += tableStart
//     for (const contentKey in block.data.content) {
//       const rowStart = '<tr>'
//       const rowEnd = '</tr>'
//       const cellStart = parseInt(contentKey) === 0 ? '<th>' : '<td>'
//       const cellEnd = parseInt(contentKey) === 0 ? '</th>' : '</td>'

//       tableHtml += rowStart
//       for (const contentElementKey in block.data.content[contentKey]) {
//         tableHtml += `${cellStart}${block.data.content[contentKey][contentElementKey]}${cellEnd}`
//       }
//       tableHtml += rowEnd
//     }
//     tableHtml += tableEnd

//     return tableHtml
//   }

//   const listParser = (block) => {
//     const listStyle = block.data.style === "unordered" ? "ul" : "ol";

//     const recursor = (items, listStyle) => {
//       const list = items.map(item => {
//         if (!item.content && !item.items.length) return `<li>${item}</li>`;

//         let list = "";
//         if (item.items.length) list = recursor(item.items, listStyle);
//         if (item.content) return `<li>${item.content}</li>` + list;
//       });

//       return `<${listStyle}>${list.join("")}</${listStyle}>`;
//     };

//     return recursor(block.data.items, listStyle);
//   }

//   for (let element of data?.blocks) {
//     if (element.type === "inlineImage" || element.type === "image") {
//       let result = editorJsParser({ inlineImage: inlineParser }).parseBlock(element);
//       finalHTML += result;
//       // console.log(result);
//     }  else if (element.type === "divider") {
//       let result = editorJsParser({ divider: dividerParser }).parseBlock(element);
//       finalHTML += result;
//       // console.log(result);
//     } else if (element.type === "raw") {
//       let result = editorJsParser({ raw: rawParser }).parseBlock(element);
//       finalHTML += result;
//       // console.log(result);
//     } else if (element.type === "list") {
//       let result = editorJsParser({ list: listParser }).parseBlock(element);
//       finalHTML += result;
//     } else if (element.type === "checklist") {
//       let result = editorJsParser({ checklist: checklistParser }).parseBlock(element);
//       finalHTML += result;
//       // console.log(result);
//     } else if (element.type === "quote") {
//       let result = editorJsParser({ quote: quoteParser }).parseBlock(element);
//       finalHTML += result;
//       // console.log(result);
//     } else if (element.type === "table") {
//       let result = editorJsParser({ table: tableParser }).parseBlock(element);
//       finalHTML += result;
//     } else {
//       let result = editorJsParser().parseBlock(element);
//       finalHTML += result;
//       // console.log(result);
//     }
//   }
//   console.log(finalHTML);
//   return finalHTML
// }

async function onChangeHandler (api, event) {
  let currentBlockIndex = editor?.blocks?.getCurrentBlockIndex()
  let currentBlock = editor?.blocks?.getBlockByIndex(currentBlockIndex)

  if (!props.readOnly) {
    const savedData = await editor.save()

    let list = {
      id: uuidv4(),
      type: "list",
      data: {
        items: [
          {
            content: "",
            items: [],
          },
        ],
      },
    };
    let divider = {
      id: uuidv4(),
      type: "divider",
      data: {
        alignment: "left",
        fullWidth: true,
      },
    };

    if (currentBlock?.name === 'header' || currentBlock?.name === 'paragraph') {
      currentBlock.save().then((value) => {
        if (value?.data?.text === "-&nbsp;") {
          savedData?.blocks?.splice(currentBlockIndex, 1)
          savedData?.blocks?.splice(currentBlockIndex, 0, list)

          editor.save();
          editor.render(savedData);

          setTimeout(() => {
            editor.caret.setToBlock(currentBlockIndex, "end")
          }, 50);
        }
        if (value?.data?.text === "---") {
          savedData?.blocks?.splice(currentBlockIndex, 1)
          savedData?.blocks?.splice(currentBlockIndex, 0, divider)

          editor.save();
          editor.render(savedData);

          setTimeout(() => {
            editor.caret.setToBlock(currentBlockIndex, "end")
          }, 50);
        }
        if (value?.data?.text?.startsWith("- ")) {
          savedData?.blocks?.splice(currentBlockIndex, 1)
          savedData?.blocks?.splice(currentBlockIndex, 0, listWithContent(value?.data?.text?.substring(2)))

          editor.save();
          editor.render(savedData);

          setTimeout(() => {
            editor.caret.setToBlock(currentBlockIndex, "end")
          }, 50);
        }
      })
    }
    emits("on-save", savedData)
  }
}
</script>

<style lang="scss">
.codex-editor:hover {
  z-index: 2;
}

.firstEditor .codex-editor {
  z-index: 2;
}

:-moz-focusring {
  outline: 0 !important;
}

.ce-block:hover {
  background-color: #F6F6F6;
  border-radius: 4px;
  cursor: pointer;
}

.editorjs-read-only-aleph {
  padding: 24px !important;

  .ce-block:hover {
    background-color: transparent;
    cursor: default;
  }
}

.editorjs-read-only-studio {
  padding: 0px !important;

  .ce-block:hover {
    background-color: transparent;
    cursor: default;
  }
}

.editor-full-width {
  .ce-block__content, .ce-toolbar__content {
    max-width: 100% !important;
  }

  .cdx-block {
    max-width: 100% !important;
  }

  * .ce-block:first-child {
    display: none !important;
  }
}

.read-only {
  .ce-block__content, .ce-toolbar__content {
    max-width: 1044px !important;
  }

  .cdx-block {
    max-width: 100% !important;
  }

  * .ce-block:first-child {
    display: none !important;
  }
}

.not-read-only {
  padding-left: 24px !important;
  padding-top: 24px !important;
  padding-right: 24px !important;
  padding-bottom: 24px !important;

  @media only screen and (min-width: 640px) and (max-width: 1024px) {
    padding-left: 60px !important;
    padding-top: 24px !important;
    padding-right: 24px !important;
    padding-bottom: 24px !important;
  }

  .ce-block__content, .ce-toolbar__content {
    max-width: 850px !important;
  }

  .cdx-block {
    max-width: 100% !important;
  }
}

.kabam {
  .ce-block__content {
    margin: 0px !important;
  }
}

.ce-toolbar__actions {
  margin-right: 0px;
}

.block-wrapper {
  margin-top: 10px;
  margin-bottom: 10px;
}

.block-wrapper  input {
  width: 100%;
  padding: 10px;
  border: 1px solid #e4e4e4;
  border-radius: 3px;
  outline: none;
  font-size: 14px;
}

.video-wrapper {
  position: relative;
  padding-bottom: 56.25%; /* 16:9 */
  height: 0;
}

.video-wrapper iframe {
  position: absolute;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  border: 0px;
}
</style>
